Eight (HDU - 1043|POJ - 1077)(A* | 双向bfs+康拓展开)
1 2 3 4
5 6 7 8
9 10 11 12
13 14 15 x
where the only legal operation is to exchange 'x' with one of the tiles with which it shares an edge. As an example, the following sequence of moves solves a slightly scrambled puzzle:
1 2 3 4 1 2 3 4 1 2 3 4 1 2 3 4
5 6 7 8 5 6 7 8 5 6 7 8 5 6 7 8
9 x 10 12 9 10 x 12 9 10 11 12 9 10 11 12
13 14 11 15 13 14 11 15 13 14 x 15 13 14 15 x
r-> d-> r->
The letters in the previous row indicate which neighbor of the 'x' tile is swapped with the 'x' tile at each step; legal values are 'r','l','u' and 'd', for right, left, up, and down, respectively.
Not all puzzles can be solved; in 1870, a man named Sam Loyd was famous for distributing an unsolvable version of the puzzle, and
frustrating many people. In fact, all you have to do to make a regular puzzle into an unsolvable one is to swap two tiles (not counting the missing 'x' tile, of course).
In this problem, you will write a program for solving the less well-known 8-puzzle, composed of tiles on a three by three
arrangement.
InputYou will receive, several descriptions of configuration of the 8 puzzle. One description is just a list of the tiles in their initial positions, with the rows listed from top to bottom, and the tiles listed from left to right within a row, where the tiles are represented by numbers 1 to 8, plus 'x'. For example, this puzzle
1 2 3
x 4 6
7 5 8
is described by this list:
1 2 3 x 4 6 7 5 8
OutputYou will print to standard output either the word ``unsolvable'', if the puzzle has no solution, or a string consisting entirely of the letters 'r', 'l', 'u' and 'd' that describes a series of moves that produce a solution. The string should include no spaces and start at the beginning of the line. Do not print a blank line between cases.
Sample Input
2 3 4 1 5 x 7 6 8
Sample Output
ullddrurdllurdruldr 题意:给出8个数和一个空位(x表示),空位可以向四个方向和数交换,求最小的操作方式试其变成 (1 2 3 4 5 6 7 8 x)
思路:奇数码问题,先判断是否有解,因为是奇数码,所以有解的情况是两个情况的逆序对奇偶相同。
另外,可以把x置换成9,然后对这个9位数进行标记,可以用map<int,int>,也可以用康托展开将其和自然数一一对应。
A*的评估函数是每个位置到其应当位置的曼哈顿距离 A* + map + string路径记录:
#include<iostream>
#include<cstdio>
#include<queue>
#include<algorithm>
#include<string.h>
#include<map>
using namespace std; struct Node
{
int cost,status;
int s[];
int pos;
int f;
string ans;
Node(int co=,int st=,int pos=,int f=,string ans=""):cost(co),status(st),pos(pos),f(f),ans(ans) {}
bool operator <(const Node x)const
{
return cost > x.cost;
}
};
map<int,int>mp;
int ways[][] = {,,-,,,,,-};
char WAYS[] = {'d','u','r','l'};
int ending;
Node start;
string ans;
int Merge(int *a,int l,int r)
{
int mid = (r+l)>>;
int i=l,j=mid+;
int b[r-l+];
int cnt = ;
int k = ;
while(i <= mid && j <= r)
{
if(a[i] <= a[j])
{
b[cnt++] = a[i++];
}
else
{
b[cnt++] = a[j++];
k += mid - i + ;
}
}
while(i <= mid)
b[cnt++] = a[i++];
while(j <= r)
b[cnt++] = a[j++];
for(int i=; i<cnt; i++)
{
a[l++] = b[i];
}
return k;
} void MER(int *a,int l,int r,int &cnt)
{
if(l >= r)
return;
int mid = (l+r)>>;
MER(a,l,mid,cnt);
MER(a,mid+,r,cnt);
cnt += Merge(a,l,r);
} int turn(int s[])
{
int cnt = ;
for(int i=; i<=; i++)
{
cnt *= ;
cnt += s[i];
}
return cnt;
} int init(char word[])
{
int a[];
for(int i=; i<=; i++)
scanf(" %c",&word[i]);
int cnt = ;
for(int i=; i<=; i++)
if((word[i]) != 'x')
a[++cnt] = word[i]-'';
int num = ;
MER(a,,cnt,num);
ending = ;
for(int i=; i<=; i++)
{
ending *= ;
ending += i;
if(word[i] == 'x')
start.s[i] = ,start.pos = i;
else
start.s[i] = word[i] - '';
}
return (num & ) == ;
} int cal(int s[])
{
int cnt = ;
for(int i=; i<=; i++)
{
if(s[i] == )
continue;
int x=(i-)/+,y=(i-)%+;
int xx=(s[i]-)/+,yy=(s[i]-)%+;
cnt += abs(x-xx)+abs(y-yy);
}
return cnt;
} bool A_bfs(Node start)
{
priority_queue<Node>que;
while(!que.empty())
que.pop();
start.status = turn(start.s);
start.f = cal(start.s);
start.cost = start.f;
que.push(start);
while(!que.empty())
{
Node tmp = que.top();
que.pop();
int status = tmp.status;
int cost = tmp.cost - tmp.f;
if(mp[status])
continue;
mp[status] = ;
if(status == ending)
{
ans = tmp.ans;
return ;
};
int x = (tmp.pos-)/+;
int y = (tmp.pos-)%+;
for(int i=; i<; i++)
{
int xx = x+ways[i][];
int yy = y+ways[i][];
if(xx < || xx > || yy < || yy > )
continue;
Node t = tmp;
t.s[(x-)*+y] = tmp.s[(xx-)*+yy];
t.s[(xx-)*+yy] = ;
t.status = turn(t.s);
t.f = cal(t.s);
t.cost = cost++t.f;
t.pos = (xx-)*+yy;
t.ans += WAYS[i];
que.push(t);
} }
return ;
} int main()
{
char word[];
while(~scanf(" %c",&word[]))
{
mp.clear();
if(init(word))
printf("unsolvable\n");
else
{
A_bfs(start);
cout << ans << endl;
}
}
}
双向bfs+康拓展开+递归路径记录(注:路径记录不能都用递归,会ME,也许姿势不对,对于从终态搜索的,因为其本身就是倒序,可以采用递推,从当前状态推过去)
#include<bits/stdc++.h>
using namespace std; struct Node
{
int cost,status;
int s[];
int pos;
Node(int co=,int st=,int pos=):cost(co),status(st),pos(pos){}
};
const int maxn = 4e5;
int fac[] = {,,,,,,,,};
int ways[][] = {,,-,,,,,-};
char WAYS[] = {'d','u','r','l'};
char FWAYS[]= {'u','d','l','r'};
char path[maxn],path2[maxn];
int pre[maxn],pre2[maxn];
bool vis[][maxn];
int ans;
queue<Node>que[];
Node start,ending;
char word[];
int a[],b[]; int cantor(int s[])
{
int sum = ;
for(int i=; i<=; i++)
{
int num = ;
for(int j=i+; j<=; j++)
{
if(s[j] < s[i])
num++;
}
sum += num*fac[-i];
}
return sum+;
} int Merge(int *a,int l,int r)
{
int mid = (r+l)>>;
int i=l,j=mid+;
int cnt = ;
int k = ;
while(i <= mid && j <= r)
{
if(a[i] <= a[j])
{
b[cnt++] = a[i++];
}
else
{
b[cnt++] = a[j++];
k += mid - i + ;
}
}
while(i <= mid)
b[cnt++] = a[i++];
while(j <= r)
b[cnt++] = a[j++];
for(int i=; i<cnt; i++)
{
a[l++] = b[i];
}
return k;
} void MER(int *a,int l,int r,int &cnt)
{
if(l >= r)
return;
int mid = (l+r)>>;
MER(a,l,mid,cnt);
MER(a,mid+,r,cnt);
cnt += Merge(a,l,r);
} int init(char word[])
{
memset(vis,,sizeof(vis));
for(int i=; i<=; i++)
scanf(" %c",&word[i]);
int cnt = ;
for(int i=; i<=; i++)
if((word[i]) != 'x')
a[++cnt] = word[i]-'';
int num = ;
MER(a,,cnt,num);
for(int i=; i<=; i++)
{
ending.s[i] = i;
if(word[i] == 'x')
start.s[i] = ,start.pos = i;
else
start.s[i] = word[i] - '';
}
start.status = cantor(start.s);
ending.status = cantor(ending.s);
ending.pos = ;
return (num & ) == ;
} bool bfs(int w)
{
int num = que[w].size();
while(num--)
{ Node tmp = que[w].front();
que[w].pop();
int status = tmp.status;
int cost = tmp.cost;
if(vis[w^][status])
{
ans = status;
return ;
}
int x = (tmp.pos-)/+;
int y = (tmp.pos-)%+;
for(int i=; i<; i++)
{
int xx = x+ways[i][];
int yy = y+ways[i][];
if(xx < || xx > || yy < || yy > )
continue;
Node t = tmp;
t.s[(x-)*+y] = tmp.s[(xx-)*+yy];
t.s[(xx-)*+yy] = ;
t.status = cantor(t.s);
if(vis[w][t.status])continue;
vis[w][t.status] = ;
t.s[(x-)*+y] = tmp.s[(xx-)*+yy];
t.s[(xx-)*+yy] = ;
t.cost = cost+;
t.pos = (xx-)*+yy;
if(w == )path[t.status] = WAYS[i],pre[t.status] = status;
else path2[t.status] = FWAYS[i],pre2[t.status] = status;
que[w].push(t);
}
}
return ;
} void out(int w)
{
if(pre[w] == -)
return;
out(pre[w]);
printf("%c",path[w]);
}
void out2(int w)
{
while(pre2[w] != -)
{
printf("%c",path2[w]);
w = pre2[w];
}
}
void solve()
{
while(!que[].empty())que[].pop();
while(!que[].empty())que[].pop();
que[].push(start);
que[].push(ending);
pre[start.status] = pre2[ending.status] = -;
vis[][start.status] = vis[][ending.status] = ;
while(!que[].empty() || !que[].empty())
{
if(bfs())
{
out(ans);
out2(ans);
puts("");
return;
}
if(bfs())
{
out(ans);
out2(ans);
puts("");
return;
}
}
} int main()
{
while(~scanf(" %c",&word[]))
{
if(init(word))
printf("unsolvable\n");
else
{
solve();
}
}
}
Eight (HDU - 1043|POJ - 1077)(A* | 双向bfs+康拓展开)的更多相关文章
- HDU 1043 & POJ 1077 Eight(康托展开+BFS+预处理)
Eight Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 30176 Accepted: 13119 Special ...
- HDU 1043 & POJ 1077 Eight(康托展开+BFS | IDA*)
Eight Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 30176 Accepted: 13119 Special ...
- Eight hdu 1043 poj 1077
Description The 15-puzzle has been around for over 100 years; even if you don't know it by that name ...
- poj 1077 Eight(双向bfs)
题目链接:http://poj.org/problem?id=1077 思路分析:题目要求在找出最短的移动路径,使得从给定的状态到达最终状态. <1>搜索算法选择:由于需要找出最短的移动路 ...
- 【HDU - 1043】Eight(反向bfs+康托展开)
Eight Descriptions: 简单介绍一下八数码问题:在一个3×3的九宫格上,填有1~8八个数字,空余一个位置,例如下图: 1 2 3 4 5 6 7 8 在上图中,由于右下角位置是空的 ...
- POJ 1077 Eight (BFS+康托展开)详解
本题知识点和基本代码来自<算法竞赛 入门到进阶>(作者:罗勇军 郭卫斌) 如有问题欢迎巨巨们提出 题意:八数码问题是在一个3*3的棋盘上放置编号为1~8的方块,其中有一块为控制,与空格相邻 ...
- cdoj 414 八数码 (双向bfs+康拓展开,A*)
一道关乎人生完整的问题. DBFS的优越:避免了结点膨胀太多. 假设一个状态结点可以扩展m个子结点,为了简单起见,假设每个结点的扩展都是相互独立的. 分析:起始状态结点数为1,每加深一层,结点数An ...
- hdu 1043 pku poj 1077 Eight (BFS + 康拓展开)
http://acm.hdu.edu.cn/showproblem.php?pid=1043 http://poj.org/problem?id=1077 Eight Time Limit: 1000 ...
- HDU 1043 Eight(双向BFS+康托展开)
http://acm.hdu.edu.cn/showproblem.php?pid=1043 题意:给出一个八数码,求出到达指定状态的路径. 思路:路径寻找问题.在这道题里用到的知识点挺多的.第一次用 ...
随机推荐
- SQL Server 数据恢复到指点时间点(完整恢复)
SQL Server 数据恢复到指点时间点(完整恢复) 高文龙关注2人评论944人阅读2017-03-20 12:57:12 SQL Server 数据恢复到指点时间点(完整恢复) 说到数据库恢复,其 ...
- Confluence 6 用户目录图例 - 只读连接 LDAP 整合本地用户组
上面的图:Confluence 连接到一 LDAP 目录,权限对本地用户组设置为只读. https://www.cwiki.us/display/CONFLUENCEWIKI/Diagrams+of ...
- gnuradio 创建cos_source
C++教程 ys_linux@computer:~$ gr_modtool nm kcd Creating out-of-tree module in ./gr-kcd... Done. Use 'g ...
- 【python】多进程与mongo
参考:http://api.mongodb.com/python/current/faq.html#using-pymongo-with-multiprocessing 如果使用了多进程,则必须在子进 ...
- Metasploit 使用后门和Rootkit维持访问
1.内存攻击指的是攻击者利用软件的漏洞,构造恶意的输入导致软件在处理输入数据时出现非预期的错误,将输入数据写入内存中的某些敏感位置,从而劫持软件控制流,转而执行外部的指令代码,造成目标系统获取远程控制 ...
- bzoj 4816
这题是莫比乌斯反演的典型题也是很有趣的题. 题意:求,其中f为为斐波那契数列 那么首先观察一下指数,发现是我们熟悉的形式,可以转化成这样的形式: 令T=kd,且假设n<m,有: 令 则原式= 这 ...
- 使用git克隆项目、从dev分支上更新代码以及将代码提交到Coding(或GitHub)上面
本教程的目的: 这是个crm项目中,有两个分支一个是master 和 dev ,master主分支,不允许提交代码,我要拉去dev分支上最新的代码,并将修改后的项目,在推送到dev分支上. 一. 1. ...
- 优先选择nullptr而不是0和NULL
我们知道:0是一个int,而不是一个指针.如果C++在一个只有指针才能够使用的上下文中发现它只有一个0,那么它会勉强将0解释成空指针,但那时一种倒退行为.C++的主要方针是0就是一个int,而不是指针 ...
- Java+selenium之WebDriver对浏览器的简单操作(一)
操作浏览器的主要方法都来自 org.openqa.selenium.WebDriver 这个接口 这些方法都是在 org.openqa.selenium.remote.RemoteWebDriver这 ...
- 51 nod 1212 无向图最小生成树(Kruckal算法/Prime算法图解)
1212 无向图最小生成树 N个点M条边的无向连通图,每条边有一个权值,求该图的最小生成树. 收起 输入 第1行:2个数N,M中间用空格分隔,N为点的数量,M为边的数量.(2 <= N < ...